Bug 1421112 - qpid-cpp: FTBFS against GCC 7 in Fedora Rawhide
Summary: qpid-cpp: FTBFS against GCC 7 in Fedora Rawhide
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: qpid-cpp
Version: 26
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Irina Boverman
QA Contact: Fedora Extras Quality Assurance
URL: http://apps.fedoraproject.org/koschei...
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-02-10 11:34 UTC by Jitka Plesnikova
Modified: 2017-03-19 00:19 UTC (History)
5 users (show)

Fixed In Version: qpid-cpp-1.35.0-2.fc25 qpid-cpp-1.35.0-2.fc24
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-03-09 13:21:23 UTC
Type: Bug


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Apache JIRA QPID-7674 0 None None None Never

Description Jitka Plesnikova 2017-02-10 11:34:36 UTC
Description of problem:
Package qpid-cpp fails to build from source against GCC 7 in Fedora Rawhide.

Version-Release number of selected component (if applicable):
1.35.0-2.fc26

Additional info:
This package is tracked by Koschei. See:
http://apps.fedoraproject.org/koschei/package/qpid-cpp

Dependency changes since last successful build:
 	gcc-c++ 	6.3.1-2.fc26 	> 	7.0.1-0.2.fc26
	libtool 	2.4.6-13.fc26 	> 	2.4.6-15.fc26
	findutils 	1:4.6.0-8.fc26 	> 	1:4.6.0-9.fc26
	libgcc 	6.3.1-2.fc26 	> 	7.0.1-0.2.fc26
	libstdc++ 	6.3.1-2.fc26 	> 	7.0.1-0.2.fc26
	gcc 	6.3.1-2.fc26 	> 	7.0.1-0.2.fc26
	libstdc++-devel 	6.3.1-2.fc26 	> 	7.0.1-0.2.fc26
	libquadmath-devel 	6.3.1-2.fc26 	> 	7.0.1-0.2.fc26
	cpp 	6.3.1-2.fc26 	> 	7.0.1-0.2.fc26
	libquadmath 	6.3.1-2.fc26 	> 	7.0.1-0.2.fc26
	libgomp 	6.3.1-2.fc26 	> 	7.0.1-0.2.fc26
	libtool-ltdl 	2.4.6-13.fc26 	> 	2.4.6-15.fc26


Build fails with error:

/builddir/build/BUILD/qpid-cpp-1.35.0/src/qpid/amqp_0_10/Codecs.cpp: In function 'qpid::types::Variant qpid::amqp_0_10::toVariant(boost::shared_ptr<qpid::framing::FieldValue>)':
/builddir/build/BUILD/qpid-cpp-1.35.0/src/qpid/amqp_0_10/Codecs.cpp:106:33: error: this statement may fall through [-Werror=implicit-fallthrough=]
       case 0x00: out.setEncoding(amqp0_10_binary);
                  ~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~
/builddir/build/BUILD/qpid-cpp-1.35.0/src/qpid/amqp_0_10/Codecs.cpp:107:7: note: here
       case 0x01: out = in->getIntegerValue<int8_t>(); break;
       ^~~~
/builddir/build/BUILD/qpid-cpp-1.35.0/src/qpid/amqp_0_10/Codecs.cpp:111:33: error: this statement may fall through [-Werror=implicit-fallthrough=]
       case 0x10: out.setEncoding(amqp0_10_binary);
                  ~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~
/builddir/build/BUILD/qpid-cpp-1.35.0/src/qpid/amqp_0_10/Codecs.cpp:112:7: note: here
       case 0x11: out = in->getIntegerValue<int16_t, 2>(); break;
       ^~~~
/builddir/build/BUILD/qpid-cpp-1.35.0/src/qpid/amqp_0_10/Codecs.cpp:114:33: error: this statement may fall through [-Werror=implicit-fallthrough=]
       case 0x20: out.setEncoding(amqp0_10_binary);
                  ~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~
/builddir/build/BUILD/qpid-cpp-1.35.0/src/qpid/amqp_0_10/Codecs.cpp:115:7: note: here
       case 0x21: out = in->getIntegerValue<int32_t, 4>(); break;
       ^~~~
/builddir/build/BUILD/qpid-cpp-1.35.0/src/qpid/amqp_0_10/Codecs.cpp:119:33: error: this statement may fall through [-Werror=implicit-fallthrough=]
       case 0x30: out.setEncoding(amqp0_10_binary);
                  ~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~
/builddir/build/BUILD/qpid-cpp-1.35.0/src/qpid/amqp_0_10/Codecs.cpp:120:7: note: here
       case 0x31: out = in->getIntegerValue<int64_t, 8>(); break;
       ^~~~
/builddir/build/BUILD/qpid-cpp-1.35.0/src/qpid/amqp_0_10/Codecs.cpp:121:33: error: this statement may fall through [-Werror=implicit-fallthrough=]
       case 0x38: out.setEncoding(amqp0_10_datetime); //treat datetime as uint64_t, but set encoding
                  ~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~

Comment 1 Alan Conway 2017-02-13 16:38:55 UTC
This is a new warning added in GCC7 - the code is correct. There may be other places where this warning will get triggered.

Can you try adding `-Wno-implicit-fallthrough` to the CMAKE_CXX_FLAGS for the build? If that fixes the problem I will add it to the default build flags upstream.

Comment 2 Jitka Plesnikova 2017-02-13 19:31:13 UTC
It fixed the problem.

https://koji.fedoraproject.org/koji/taskinfo?taskID=17842901

It also fixed the BZ#1421110.

Comment 3 Alan Conway 2017-02-14 20:11:13 UTC
Fixed upstream https://issues.apache.org/jira/browse/QPID-7674

Comment 4 Fedora Update System 2017-02-24 15:40:47 UTC
qpid-cpp-1.35.0-2.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2017-4bae7f5342

Comment 5 Fedora Update System 2017-02-25 01:53:06 UTC
qpid-cpp-1.35.0-2.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-4bae7f5342

Comment 6 Fedora Update System 2017-02-27 14:37:47 UTC
qpid-cpp-1.35.0-2.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2017-1b8145072a

Comment 7 Fedora End Of Life 2017-02-28 11:14:49 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 26 development cycle.
Changing version to '26'.

Comment 8 Fedora Update System 2017-03-01 02:50:23 UTC
qpid-cpp-1.35.0-2.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-1b8145072a

Comment 9 Fedora Update System 2017-03-09 13:21:23 UTC
qpid-cpp-1.35.0-2.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.

Comment 10 Fedora Update System 2017-03-19 00:19:24 UTC
qpid-cpp-1.35.0-2.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.